<?php
/**
 * Created by PhpStorm.
 * User: imtiyaazsalie
 * Date: 2018/08/13
 * Time: 11:49
 */

class ProcessPargoShipping
{

    public function postOrder($order){

        $ch = curl_init ("https://api.pargo.co.za/v8/warehouses");

        curl_setopt ($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);

        $headers = array(
            "Content-Type:application/json",
            "Authorization: ".get_option('woocommerce_wp_pargo_settings')['pargo_auth_token']
        );

        curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);

        $response = curl_exec($ch);

        if($response){
           $wareHouse  = json_decode($response)->data[0]->warehouseCode;
        }
        else{
            print_r(curl_error($ch));
        }

        curl_close($ch);

        $data = array(
            "depo" => array (
                "warehouseCode" => $wareHouse
            ),
            "consignee" => array (
                "firstName" => $order->data['billing']['first_name'],
                "lastName" => $order->data['billing']['last_name'],
                "phoneNumber" => $order->data['billing']['phone'],
                "mobileNumber" => $order->data['billing']['phone'],
                "email" => $order->data['billing']['email'],
                "address1" => $order->data['billing']['address_1'],
                "address2" => $order->data['billing']['address_2'],
                "suburb" => "",
                "postalCode" =>  $order->data['billing']['postcode'],
                "city" => $order->data['billing']['city'],
                "language" => "ZA"
            ),
            "delivery" => array (
                "pargoPointCode" =>  get_post_meta($order->id, 'pargo_pc', true)
            ),
            "transportdata" => array (
                "insurance" => "0",
                "dimensions" => "23",
                "weight" => "1.635",
                "financialValue" => "0",
                "shippersReference" => (string)$order->get_id()
            )
        );

        $data = json_encode($data);


        $ch = curl_init ("https://api.pargo.co.za/v8/orders");

        curl_setopt ($ch, CURLOPT_POST, true);
        curl_setopt ($ch, CURLOPT_POSTFIELDS, $data);
        curl_setopt ($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);

        $headers = array(
            "Content-Type:application/json",
            "Authorization: ".get_option('woocommerce_wp_pargo_settings')['pargo_auth_token']
        );

        curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);

        $response = curl_exec($ch);

        if($response){
            update_post_meta( $order->id, 'pargo_waybill', ['waybill' => json_decode($response)->data->waybillNumber, 'label' => json_decode($response)->data->labelUrl ]  );
            $my_value = get_post_meta( $order->id, 'pargo_waybills', true );
            // The text for the note
            if(json_decode($response)->success == false){
                $note = __("Pargo Shipment failed ".json_decode($response)->errors[0]->detail);
                $order->add_order_note( $note );
                $order->save;
            }
            else {
                $note = __("Pargo Shipment processed.");
                $order->add_order_note( $note );
                $order->save;
            }

        }
        else{
        }

        curl_close($ch);


        $url = $_SERVER['REQUEST_URI'];
        $parsed = parse_url($url);
        $path = $parsed['path'];
        unset($_GET['ship-now']);
        if(!empty(http_build_query($_GET))){
            header("Location: ".$path .'?'. http_build_query($_GET)); //reload page

        }
    }

}

